//+------------------------------------------------------------------+
//|                                           USD Currency Index.mq4 |
//|                                       Copyright  2016 "BeerGod" |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015 BeerGod"
#property link      "http://www.forex4you.org/?affid=bdbda7b"
#property version   "1.0"
#property strict

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 clrRed
#property indicator_width1 2
#property indicator_color2 clrBlue
#property indicator_width2 1
#property indicator_style2 2
#property indicator_color3 clrNONE
#property indicator_width3 1
#property indicator_style3 2
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

extern int short_term_SMA_period=13;
extern int long_term_EMA_period =34;
//int winind;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"USDX");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,DoubleToString(short_term_SMA_period,0)+"SMA");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,DoubleToString(long_term_EMA_period,0)+"EMA");
   IndicatorShortName("Dollar Currency Index");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=1+short_term_SMA_period;
//---- main loop
   for(int i=0; i<limit; i++)
     {
      ExtMapBuffer1[i]=50.14348112*MathPow(iClose("EURUSD",PERIOD_D1,i),-0.576)*
                       MathPow(iClose("USDJPY",PERIOD_D1,i),0.136)*MathPow(iClose("GBPUSD",PERIOD_D1,i),-0.119)*
                       MathPow(iClose("USDCAD",PERIOD_D1,i),0.091)*MathPow(iClose("USDSEK",PERIOD_D1,i),0.042)*
                       MathPow(iClose("USDCHF",PERIOD_D1,i),0.036);
     }
   int i;
   for(i=limit; i>=0; i--)
     {
      ExtMapBuffer2[i]=0;
      ExtMapBuffer3[i]=0;

      for(int z=0; z<short_term_SMA_period; z++)ExtMapBuffer2[i]=ExtMapBuffer2[i]+ExtMapBuffer1[i+z];    // 
      ExtMapBuffer2[i] = ExtMapBuffer2[i]/short_term_SMA_period;                                         //   -  SMA

      if(ExtMapBuffer1[i]>0)ExtMapBuffer3[i]=ExtMapBuffer1[i]*(2.0/(long_term_EMA_period+1))+ExtMapBuffer3[i+1]*(1-(2.0/(long_term_EMA_period+1)));   // EMA   
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+